/*!
@ng-dynamic-forms/ui-foundation 5.0.0 2017-11-01 20:25 UTC
Copyright (c) 2016-2017, Udo Schöfer http://www.udos86.de

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ng-dynamic-forms/core'), require('@angular/common'), require('angular2-text-mask')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', '@ng-dynamic-forms/core', '@angular/common', 'angular2-text-mask'], factory) :
	(factory((global.ngDF = global.ngDF || {}, global.ngDF.foundationUI = {}),global.ng.core,global.ng.forms,global.ngDF.core,global.ng.common,global['angular2-text-mask']));
}(this, (function (exports,core,forms,core$1,common,angular2TextMask) { 'use strict';

var __extends$1 = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DynamicFoundationFormControlComponent = (function (_super) {
    __extends$1(DynamicFoundationFormControlComponent, _super);
    function DynamicFoundationFormControlComponent(changeDetectorRef, validationService) {
        var _this = _super.call(this, changeDetectorRef, validationService) || this;
        _this.changeDetectorRef = changeDetectorRef;
        _this.validationService = validationService;
        _this.bindId = true;
        _this.context = null;
        _this.hasErrorMessaging = false;
        _this.blur = new core.EventEmitter();
        _this.change = new core.EventEmitter();
        _this.focus = new core.EventEmitter();
        return _this;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    DynamicFoundationFormControlComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        _super.prototype.ngOnChanges.call(this, changes);
        if (changes["model"]) {
            this.type = DynamicFoundationFormControlComponent.getFormControlType(this.model);
        }
    };
    /**
     * @param {?} model
     * @return {?}
     */
    DynamicFoundationFormControlComponent.getFormControlType = /**
     * @param {?} model
     * @return {?}
     */
    function (model) {
        switch (model.type) {
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return 1 /* Array */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return 2 /* Checkbox */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return 3 /* Group */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return 4 /* Input */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return 5 /* RadioGroup */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return 6 /* Select */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SWITCH:
                return 7 /* Switch */;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return 8 /* TextArea */;
            default:
                return null;
        }
    };
    DynamicFoundationFormControlComponent.decorators = [
        { type: core.Component, args: [{
                    selector: "dynamic-foundation-form-control,dynamic-form-foundation-sites-control",
                    template: "<div [formGroup]=\"group\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\"><div *ngIf=\"type !== 2 && model.label\" [ngClass]=\"model.cls.grid.label\"><label [class.is-invalid-label]=\"showErrorMessages\" [for]=\"model.id\" [innerHTML]=\"model.label\" [ngClass]=\"model.cls.element.label\"></label></div><ng-container *ngTemplateOutlet=\"templates[0]?.templateRef; context: model\"></ng-container><div [ngClass]=\"model.cls.grid.control\"><ng-container [ngSwitch]=\"type\"><div *ngSwitchCase=\"1\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"model.cls.element.control\"><div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\" [formGroupName]=\"idx\" [ngClass]=\"[model.cls.element.group, model.cls.grid.group]\"><dynamic-foundation-form-control *ngFor=\"let controlModel of groupModel.group\" [bindId]=\"false\" [context]=\"groupModel\" [group]=\"control.at(idx)\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [templates]=\"templateList\" [ngClass]=\"[controlModel.cls.element.host, controlModel.cls.grid.host]\" (dfBlur)=\"onBlur($event)\" (dfChange)=\"onValueChange($event)\" (dfFocus)=\"onFocus($event)\"></dynamic-foundation-form-control><ng-container *ngTemplateOutlet=\"templates[2]?.templateRef; context: groupModel\"></ng-container></div></div><label *ngSwitchCase=\"2\"><input type=\"checkbox\" [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [indeterminate]=\"model.indeterminate\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" [tabindex]=\"model.tabIndex\" [value]=\"model.value\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"><span [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\" [innerHTML]=\"model.label\"></span></label><fieldset *ngSwitchCase=\"3\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><dynamic-foundation-form-control *ngFor=\"let itemModel of model.group\" [group]=\"control\" [hasErrorMessaging]=\"itemModel.hasErrorMessages\" [model]=\"itemModel\" [templates]=\"templateList\" [ngClass]=\"[itemModel.cls.element.host, itemModel.cls.grid.host]\" (dfBlur)=\"onBlur($event)\" (dfChange)=\"onValueChange($event)\" (dfFocus)=\"onFocus($event)\"></dynamic-foundation-form-control></fieldset><div *ngSwitchCase=\"4\" class=\"input-group\"><span *ngIf=\"model.prefix\" class=\"input-group-label\" [innerHTML]=\"model.prefix\"></span> <input class=\"input-group-field\" [attr.accept]=\"model.accept\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [autocomplete]=\"model.autoComplete\" [autofocus]=\"model.autoFocus\" [class.is-invalid-input]=\"showErrorMessages\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [tabindex]=\"model.tabIndex\" [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\" [type]=\"model.inputType\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"> <span *ngIf=\"model.suffix\" class=\"input-group-label\" [innerHTML]=\"model.suffix\"></span><datalist *ngIf=\"hasList\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div><fieldset *ngSwitchCase=\"5\" role=\"radiogroup\" [dynamicId]=\"bindId && model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [tabindex]=\"model.tabIndex\" (change)=\"onValueChange($event)\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><label *ngFor=\"let option of model.options$ | async\" [ngClass]=\"model.cls.element.option\"><input type=\"radio\" [formControlName]=\"model.id\" [name]=\"model.name\" [value]=\"option.value\" (blur)=\"onBlur($event)\" (focus)=\"onFocus($event)\"><span [innerHTML]=\"option.label\"></span></label></fieldset><select *ngSwitchCase=\"6\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" [tabindex]=\"model.tabIndex\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"><option *ngFor=\"let option of model.options$ | async\" [disabled]=\"option.disabled\" [ngValue]=\"option.value\">{{ option.label }}</option></select><div *ngSwitchCase=\"7\" class=\"switch\" [ngClass]=\"model.cls.element.control\"><input type=\"checkbox\" class=\"switch-input\" [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [required]=\"model.required\" [tabindex]=\"model.tabIndex\" [value]=\"model.value\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"><label class=\"switch-paddle\" [for]=\"model.id\"><span class=\"switch-active\" aria-hidden=\"true\">{{ model.onLabel }}</span> <span class=\"switch-inactive\" aria-hidden=\"true\">{{ model.offLabel }}</span></label></div><textarea *ngSwitchCase=\"8\" [class.is-invalid-input]=\"showErrorMessages\" [cols]=\"model.cols\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [tabindex]=\"model.tabIndex\" [wrap]=\"model.wrap\" (blur)=\"onBlur($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocus($event)\"></textarea></ng-container><p *ngIf=\"showHint\" class=\"help-text\" [ngClass]=\"model.cls.element.hint\" [innerHTML]=\"model.hint\"></p></div><ul *ngIf=\"showErrorMessages\" [ngClass]=\"[model.cls.element.errors, model.cls.grid.errors]\"><li *ngFor=\"let message of errorMessages\" class=\"form-error is-visible\">{{ message }}</li></ul><ng-container *ngTemplateOutlet=\"templates[1]?.templateRef; context: model\"></ng-container><ng-content></ng-content></div>"
                },] },
    ];
    /** @nocollapse */
    DynamicFoundationFormControlComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef, },
        { type: core$1.DynamicFormValidationService, },
    ]; };
    DynamicFoundationFormControlComponent.propDecorators = {
        "contentTemplateList": [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] },],
        "inputTemplateList": [{ type: core.Input, args: ["templates",] },],
        "bindId": [{ type: core.Input },],
        "context": [{ type: core.Input },],
        "group": [{ type: core.Input },],
        "hasErrorMessaging": [{ type: core.Input },],
        "model": [{ type: core.Input },],
        "blur": [{ type: core.Output, args: ["dfBlur",] },],
        "change": [{ type: core.Output, args: ["dfChange",] },],
        "focus": [{ type: core.Output, args: ["dfFocus",] },],
    };
    return DynamicFoundationFormControlComponent;
}(core$1.DynamicFormControlComponent));

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DynamicFoundationFormComponent = (function (_super) {
    __extends(DynamicFoundationFormComponent, _super);
    function DynamicFoundationFormComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.blur = new core.EventEmitter();
        _this.change = new core.EventEmitter();
        _this.focus = new core.EventEmitter();
        return _this;
    }
    DynamicFoundationFormComponent.decorators = [
        { type: core.Component, args: [{
                    selector: "dynamic-foundation-form",
                    template: "<dynamic-foundation-form-control *ngFor=\"let controlModel of model; trackBy: trackByFn\" [group]=\"group\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [ngClass]=\"[controlModel.cls.element.host, controlModel.cls.grid.host]\" [templates]=\"templates\" (dfBlur)=\"onEvent($event, 'blur')\" (dfChange)=\"onEvent($event, 'change')\" (dfFocus)=\"onEvent($event, 'focus')\"></dynamic-foundation-form-control>"
                },] },
    ];
    /** @nocollapse */
    DynamicFoundationFormComponent.ctorParameters = function () { return []; };
    DynamicFoundationFormComponent.propDecorators = {
        "group": [{ type: core.Input },],
        "model": [{ type: core.Input },],
        "blur": [{ type: core.Output, args: ["dfBlur",] },],
        "change": [{ type: core.Output, args: ["dfChange",] },],
        "focus": [{ type: core.Output, args: ["dfFocus",] },],
        "templates": [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] },],
        "components": [{ type: core.ViewChildren, args: [DynamicFoundationFormControlComponent,] },],
    };
    return DynamicFoundationFormComponent;
}(core$1.DynamicFormComponent));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DynamicFormsFoundationUIModule = (function () {
    function DynamicFormsFoundationUIModule() {
    }
    DynamicFormsFoundationUIModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        forms.ReactiveFormsModule,
                        angular2TextMask.TextMaskModule,
                        core$1.DynamicFormsCoreModule
                    ],
                    declarations: [
                        DynamicFoundationFormControlComponent,
                        DynamicFoundationFormComponent
                    ],
                    exports: [
                        core$1.DynamicFormsCoreModule,
                        DynamicFoundationFormControlComponent,
                        DynamicFoundationFormComponent
                    ]
                },] },
    ];
    /** @nocollapse */
    DynamicFormsFoundationUIModule.ctorParameters = function () { return []; };
    return DynamicFormsFoundationUIModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

exports.DynamicFoundationFormComponent = DynamicFoundationFormComponent;
exports.DynamicFoundationFormControlComponent = DynamicFoundationFormControlComponent;
exports.DynamicFormsFoundationUIModule = DynamicFormsFoundationUIModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ui-foundation.umd.js.map
